cmake-based recipe with subdir fails to move subdir if contained folder exists on top level

2014-10-29 22:28 - Florian Lier

Status: Resolved Start date: 2014-10-29

Priority: High Due date:  

Assignee: Jan Moringen % Done: 100%

Category: build-generator Estimated time: 0.00 hour

Target version: Toolkit 0.1 Spent time: 3.90 hours

Description

If you have a look at the YARP-bindings folder structure:

https://github.com/robotology/yarp

The bindings folder is located in $YARP_ROOT/bindings. If you add a "sub-directory" variable to your recipe, which is needed in this

case, the analysis works well. However, the according Jenkins job is then comprised of two build steps:

1.

mv $(find "bindings" -maxdepth 1 -mindepth 1) .

2.

cmake config, compile & install ...

1. will already fail because the folder "bindings" contains a folder called "src" which also exists in $YARP_ROOT folder (c.f. github)

I am not so sure if this is a corner case or not --- however I guess we need to address this.

History

#1 - 2014-10-29 22:29 - Florian Lier

- Description updated

#2 - 2014-10-29 22:30 - Florian Lier

- Description updated

#3 - 2014-10-29 23:35 - Florian Lier

See: 

http://opensource.cit-ec.de/projects/citk/repository/revisions/f4b0358c58a47cb40929ec712a869b01ee6e99a2/entry/projects/yarp-python-bindings.proj

ect

#4 - 2014-10-30 02:11 - Jan Moringen

- Status changed from New to Resolved

- % Done changed from 0 to 100

Should be fixed in master and 0.3 branches of the generator.
#5 - 2014-10-30 10:56 - Florian Lier

It seems that at least in the current *.tar.gz (which gets deployed after each successful build on cor.ci) the issue is not fixed:

[flier@silver]-[/homes/flier/Projects/Ongoing/CITK/build-gen/jenkins]

[10:52]$ ./job-configurator --version

build-generator version 0.3.36

 

mv $(find "bindings" -maxdepth 1 -mindepth 1) .

#6 - 2014-10-30 11:01 - Florian Lier

Stop! There is something from with my jenkins installation ;) Sorry. Will update this topic soon!

#7 - 2014-10-30 11:08 - Florian Lier

Okay, thanks Jan. Fix is confirmed!

find . -mindepth 1 -maxdepth 1 -not -name "bindings" -exec rm -rf {} \;

# Uniquely rename directory.

temp=$(mktemp -d ./XXXXXXXX)

mv "bindings" "${temp}/"

# Move contents to toplevel workspace directory.

find "${temp}" -mindepth 2 -maxdepth 2 -exec mv {} . \;

rm -r "${temp}"

#8 - 2014-11-22 10:10 - Simon Schulz

- Status changed from Resolved to Feedback

- % Done changed from 100 to 80

this seems to be still broken if the subdir is something like "client/cpp"

(see flobidev-core-client_cpp.project)

#9 - 2014-11-22 10:47 - Simon Schulz

fix: please use
$num_of_slashes_in_name=1

find . -mindepth 1 -maxdepth (1+ $num_of_slashes_in_name) -not -samefile "client/cpp"

#10 - 2014-11-22 11:00 - Simon Schulz

the last thing did not work properly,

this is working:

1. Uniquely rename directory.

temp=$(mktemp -d /tmp/XXXXXXXX)

mv client/cpp/* "${temp}/"

rm -rf *

1. Move contents to toplevel workspace directory.

mv ${temp}/* .

rm -r "${temp}"

#11 - 2014-11-22 15:13 - Florian Lier

I can confirm this. This only happens if the subdir is "two" levels, i.e, "client/cpp". For one subfolder like "client" the current implementation works.

[flier@dev]-[/home/flier/Projects/Ongoing/citk/jenkins]

[14:51]$ ./job-configurator --version

build-generator version 0.3.37

#12 - 2014-11-22 15:51 - Florian Lier

Proposal for search command:

find . -type d | grep -v client/cpp

#13 - 2014-11-24 09:40 - Jan Moringen

Simon Schulz wrote:

this is working:

> # Uniquely rename directory.

> temp=$(mktemp -d /tmp/XXXXXXXX)

> mv client/cpp/* "${temp}/"

>

> rm -rf *

>

> # Move contents to toplevel workspace directory.

> mv ${temp}/* .
> rm -r "${temp}"

> 

 

I think Jenkins jobs should not modify files outside their respective workspace. Also, I think mv … /tmp/ would fail if /tmp/ was on a different filesystem.

#14 - 2014-11-24 09:48 - Simon Schulz

Why should that fail?

You are right, it would be nice to stay in the prefix with all the stuff. But that one works for me.

The strange thing is the build generator generated code also fails for single level directories as well... This was working some time ago

#15 - 2014-11-24 09:58 - Jan Moringen

Simon Schulz wrote:

Why should that fail?

 

It wouldn't. I confused mv(1) and rename(2).

The strange thing is the build generator generated code also fails for single level directories as well... This was working some time ago

 

There was some problem with sub-directory values ending with or without "/". Do you use the most recent 0.3 version?

#16 - 2014-11-26 10:02 - Florian Lier

- File subdir-test.sh added

Proposal #2

#17 - 2014-11-26 14:32 - Florian Lier

- Status changed from Feedback to Resolved

- % Done changed from 80 to 100

Thanks Jan!
Is fixed in build-gen 0.3.38

Files

subdir-test.sh 537 Bytes 2014-11-26 Florian Lier
